﻿using BepInEx;
using BepInEx.Configuration;
using RoR2;
using EntityStates;
using EntityStates.Treebot;
using UnityEngine;
using UnityEngine.Networking;
using System.Security;
using System.Security.Permissions;

[module: UnverifiableCode]
[assembly: SecurityPermission(SecurityAction.RequestMinimum, SkipVerification = true)]

namespace FriendFetchMod
{
    [BepInPlugin("xyz.yekoc.FetchAFriend", "Fetch-a-friend Quest","1.0.0" )]
    public class FriendFetchPlugin : BaseUnityPlugin
    {
	public static ConfigEntry<bool> items {get; set;}
	public static ConfigEntry<bool> respawn {get; set;}
        private void Awake()
        {
	  items = Config.Bind("Configuration","Item Share",true,"Whether Rex gets a copy of your items,default:True");
	  respawn = Config.Bind("Configuration","Revival",false,"Lets your new friend transcend death after teleporting to a new stage,default:False");
	  On.EntityStates.Treebot.UnlockInteractable.Unlock.OnEnter += (orig,self) => {
		orig(self);
		CharacterBody charBod = self.GetComponent<PurchaseInteraction>().lastActivator.GetComponent<CharacterBody>();
		if(self.isAuthority){
		 CharacterMaster rex = new MasterSummon{
		   masterPrefab = MasterCatalog.FindMasterPrefab("TreebotMonsterMaster"),
		   summonerBodyObject = charBod.gameObject,
		   ignoreTeamMemberLimit = true,
		   inventoryToCopy = (items.Value? charBod.inventory : null),
		   useAmbientLevel = new bool?(true),
		   position = self.transform.position + Vector3.up,
		   rotation = Quaternion.identity, 
		 }.Perform();
		 DontDestroyOnLoad(rex);
		 rex.destroyOnBodyDeath = !(respawn.Value);
		}
		 if(self.modelLocator)
		 EntityState.Destroy(self.modelLocator.gameObject);
	 };
	}
	
    }
}
